package algorithms;

import geometry.Geometry;
import geometry.LineSegment;
import geometry.Ponto;
import geometry.iPoint;
import grafico.InterfaceGrafica;

import java.awt.Color;
import java.util.ArrayList;

public class PlanarPointSetTriangulation implements Runnable {
	
	private ArrayList<iPoint> points;
	private InterfaceGrafica ig;
	
//	public PlanarPointSetTriangulation(InterfaceGrafica ig, ArrayList objects) {
//		this.ig = ig;
//		
//		if(objects.get(0) instanceof Ponto || objects.get(0) instanceof iPoint){
//			for(Object o : objects){
//				if(o instanceof Ponto){
//					points.add( (Ponto) o);
//				} else if(o instanceof iPoint)
//					points.add(new Ponto(((iPoint) o).getX(), ((iPoint) o).getY()));
//			}
//		}			
//	}
	
	public PlanarPointSetTriangulation(InterfaceGrafica ig, ArrayList<iPoint> points) {
		this.ig = ig;
		this.points = points;
	}
	
	public void triangulate(){
		
		ig.setRunning(true);
		
		// Segments added
		ArrayList<LineSegment> segments = new ArrayList<LineSegment>();
		
		ig.limpaTela(1);
		ig.pintaPontos(points, 1);
		ig.pintaTelaSemDelay(1);
		
		for(int i = 0; i < points.size(); i++){
			for(int j = i + 1; j < points.size(); j++){
				boolean inter = false;
				LineSegment seg = new LineSegment(points.get(i), points.get(j));
				
				ig.copiaTela(1, 2);
				ig.pintaTela(2);
				ig.pintaSegmentoDeReta(points.get(i).getX(), points.get(i).getY(), 
									   points.get(j).getX(), points.get(j).getY(), Color.black, 2);
				ig.pintaTela(2);
				
				
				for(LineSegment l : segments){
					if(Geometry.intersectProper(l, seg)){
						inter = true;
						break;
					}
				}
				if(!inter){
					segments.add(seg);
					ig.pintaSegmentoDeReta(points.get(i).getX(), points.get(i).getY(), 
							   			   points.get(j).getX(), points.get(j).getY(), Color.black, 1);
				}
				ig.pintaTela(1);
			}
		}
		ig.setRunning(false);
	}
	
	public void run(){
		triangulate();				
	}
}
