package geometry;

import java.util.ArrayList;

public class Polygon {
	private int size;
	private Vertex head;
	
	public Polygon(){
		setHead(null);
		setSize(0);
		createPolygon();
	}
	
	public Polygon(ArrayList<iPoint> points){
		setHead(null);
		setSize(0);
		
		if(points.size() < 3){
			createPolygon();
		} else {
			for(iPoint p : points){
				add(new Vertex(p));
			}
		}
	}
	
	private void createPolygon(){
		
		add(new Vertex(30, 30));
		add(new Vertex(300, 210));
		add(new Vertex(360, 90));
		add(new Vertex(520, 24));
		add(new Vertex(390, 410));
		add(new Vertex(360, 420));
		add(new Vertex(330, 360));
		add(new Vertex(400, 270));
		add(new Vertex(240, 300));
		add(new Vertex(180, 420));
		add(new Vertex(300, 450));
		add(new Vertex(210, 530));
		add(new Vertex(30, 510));
		add(new Vertex(60, 390));
		add(new Vertex(90, 450));
		add(new Vertex(150, 240));
		add(new Vertex(30, 270));
		add(new Vertex(150, 150));
	}
	
	public void add(Vertex v){
		if(getHead() == null){
			setHead(v);
			getHead().setVNext(v);
			getHead().setVPrev(v);
		} else {
			v.setVNext(getHead());
			v.setVPrev(getHead().getVPrev());
			getHead().setVPrev(v);
			v.getVPrev().setVNext(v);
		}
		setSize(getSize() + 1);
	}
	
	public void remove(Vertex v){
		
	}
	
	public void setHead(Vertex head) {
		this.head = head;
	}

	public Vertex getHead() {
		return head;
	}

	public void setSize(int size) {
		this.size = size;
	}

	public int getSize() {
		return size;
	}

	public ArrayList<Vertex> getVertexList() {
		ArrayList<Vertex> vertices = new ArrayList<Vertex>();
		Vertex v = getHead();
		do {
			vertices.add(v);
			v = v.getVNext();
		} while(v != getHead());
		return vertices;
	}
	
	// TODO - GAMBI, ARRUMAR ISSO
	public void makeEdgeList(){
		Vertex v = head;
		do {
			Edge e = new Edge(v, v.getVNext());
			v.setENext(e);
			v.getVNext().setEPrev(e);
			v = v.getVNext();
		} while(v != head);
	}
	
	Vertex getHighest(){
		Vertex v = getHead();
		Vertex highest = null;

		do {

			if(highest == null || v.getPoint().getY() > highest.getPoint().getY())
				highest = v;

			v = v.getVNext();
		} while(v != getHead());
		
		return highest;
	}
	
	Vertex getLowest(){
		Vertex v = getHead();
		Vertex lowest = null;

		do {

			if(lowest == null || v.getPoint().getY() < lowest.getPoint().getY())
				lowest = v;

			v = v.getVNext();
		} while(v != getHead());
		
		return lowest;
	}
	
	public boolean isMonotone(){
			
		Vertex highest = getHighest();
		Vertex lowest = getLowest();
		
		for(Vertex v = highest; v != lowest; v = v.getVNext()){
			if(v.getPoint().getY() <= v.getVNext().getPoint().getY())
				return false;			
		}
		
		for(Vertex v = highest; v != lowest; v = v.getVPrev()){
			if(v.getPoint().getY() <= v.getVPrev().getPoint().getY())
				return false;			
		}
		
		return true;
	}
	
}
