package geometry;

import java.util.Vector;

public class Ponto {
	private static final double MINPOINTSPACING = 30.0;
	private double x;
	private double y;
	
	public Ponto(double x,double y) {
		this.x = x;
		this.y = y;
	}
	
	public double dist(Ponto ponto) {
		double vetorX = ponto.getX() - this.getX();
		double vetorY = ponto.getY() - this.getY();
		return Math.sqrt(vetorX*vetorX + vetorY*vetorY);
	}

	public double getY() {
		return y;
	}

	public double getX() {
		return x;
	}

	public static Vector<Ponto> geraPontos(int qtde,int maxX,int maxY) {
		int cnt = 0;
		Vector<Ponto> pontos = new Vector<Ponto>();
		while(cnt < qtde){
			boolean adiciona = true;
			Ponto tmp = new Ponto(Math.random()*(maxX - 10) + 5, Math.random()*(maxY - 10) + 5); 
			for(int j = 0; j < pontos.size(); j++){
				if(tmp.dist(pontos.get(j)) <= MINPOINTSPACING){
					adiciona = false;
				}				
			}
			if(adiciona){
				pontos.add(tmp);
				cnt++;
			}
		}
		return pontos;
	}

	public void setX(double x) {
		this.x = x;		
	}
	
	public void setY(double y) {
		this.y = y;		
	}

}
