package geometry;

import java.util.ArrayList;

public class TriangleTreeNode {
	private Triangle triangle;
	public ArrayList<TriangleTreeNode> children;
	private boolean leaf = true;
	
	public TriangleTreeNode(Triangle triangle){
		children = new ArrayList<TriangleTreeNode>();
		
		this.setTriangle(triangle);
	}
	
	public TriangleTreeNode(Vertex v1, Vertex v2, Vertex v3){
		this(new Triangle(v1, v2, v3));
	}
	
	public TriangleTreeNode get(int i){
		return children.get(i);
	}

	public void setLeaf(boolean leaf) {
		this.leaf = leaf;
	}

	public boolean isLeaf() {
		return leaf;
	}
	
	public boolean contains(iPoint p){
		return getTriangle().contains(p);
	}

	public void setTriangle(Triangle triangle) {
		this.triangle = triangle;
	}

	public Triangle getTriangle() {
		return triangle;
	}
}
