package geometry;

public class Vertex {
	private int index;
	private iPoint point;
	private boolean ear;
	
	// Para o algoritmo de monotonização (Split, Merge, ...)
	private int status;
	
	// Em que cadeia está o vértice (Esquerda = 0, Direita = 1)
	private int chain;
	
	// Counter-clockwise order
	private Vertex vNext;
	private Vertex vPrev;
	
	private Edge eNext;
	private Edge ePrev;
	
	public Vertex(int x, int y){
		setPoint(new iPoint(x, y));
	}
	
	public Vertex(iPoint point){
		this(point.getX(), point.getY());
	}
	
	public Vertex(int index, iPoint point, Vertex vNext, Vertex vPrev){
		setIndex(index);
		setPoint(point);
		setVNext(vNext);
		setVPrev(vPrev);
		setEar(false);
	}

	public void setPoint(iPoint point) {
		this.point = point;
	}
	
	public void setPoint(int x, int y) {
		this.point = new iPoint(x, y);
	}

	public iPoint getPoint() {
		return point;
	}

	public void setIndex(int index) {
		this.index = index;
	}

	public int getIndex() {
		return index;
	}

	public void setEar(boolean ear) {
		this.ear = ear;
	}

	public boolean isEar() {
		return ear;
	}

	public void setStatus(int status) {
		this.status = status;
	}

	public int getStatus() {
		return status;
	}

	public void setChain(int chain) {
		this.chain = chain;
	}

	public int getChain() {
		return chain;
	}

	public void setVPrev(Vertex vPrev) {
		this.vPrev = vPrev;
	}

	public Vertex getVPrev() {
		return vPrev;
	}

	public void setVNext(Vertex vNext) {
		this.vNext = vNext;
	}

	public Vertex getVNext() {
		return vNext;
	}

	public void setENext(Edge eNext) {
		this.eNext = eNext;
	}

	public Edge getENext() {
		return eNext;
	}

	public void setEPrev(Edge ePrev) {
		this.ePrev = ePrev;
	}

	public Edge getEPrev() {
		return ePrev;
	}
	
}
