package principal;

import geometry.Ponto;
import grafico.InterfaceGrafica;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.Vector;

import algorithms.MinDist;


public class LeituraDeDados {
	
	private static InterfaceGrafica interfaceGrafica;
	private static MinDist minDist;
	private static Vector<Ponto> pontos;
	
	public static void le(File file) {
		
		try {
			
			Scanner s = new Scanner(file);
			pontos = new Vector<Ponto>();
			while(s.hasNext()){
				int x = s.nextInt();
				if(!s.hasNext())return;
				
				int y = s.nextInt();
				
				pontos.add(new Ponto(x,y));
			}
			interfaceGrafica.limpaTela(0);
			for(int i = 0;i < pontos.size();i++){
				interfaceGrafica.pintaPonto(pontos.get(i), 0);
			}
			interfaceGrafica.pintaTela(0);
			
			minDist.setPontos(pontos);
			
		} catch (FileNotFoundException e) {
		}
		
	}

	public synchronized static void setInterfaceGrafica(InterfaceGrafica ig) {
		interfaceGrafica = ig;
	}

	public synchronized static InterfaceGrafica getInterfaceGrafica() {
		return interfaceGrafica;
	}

	public synchronized static void setMinDist(MinDist md) {
		minDist = md;
	}

	public synchronized static MinDist getMinDist() {
		return minDist;
	}
	

}
